#include <cstdio>
#include <cmath>
using namespace std;

static long double power(long double r, long long N)
{
	if (N == 0) return 1;
	if (N == 1) return r;
	long double d = power(r, N/2);
	d = d*d;
	if (N%2 == 1) d *= r;
	return d;
}

int main()
{
	long long X, Y, N;
	long double r;
	while (1){
		scanf("%lld %lld %lld %Lf", &X, &Y, &N, &r);
		if (X==0 && Y==0 && N==0) return 0;
		r = r/1200 + 1;
		long double rn = power(r, N*12);
		long double res = X*rn - Y*(1-rn)/(1-r);
		if (res <= 0) printf("YES\n");
		else printf("NO\n");
	}
}
